Index: exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- exampleparties/anac2019/agentgg/pom.xml	(revision 14)
+++ exampleparties/anac2019/agentgg/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>1.4,0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -32,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>issuevalue</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -38,5 +39,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -44,10 +45,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
@@ -59,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- exampleparties/anac2019/winkyagent/pom.xml	(revision 14)
+++ exampleparties/anac2019/winkyagent/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -32,5 +33,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>issuevalue</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -38,5 +39,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -44,10 +45,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
@@ -59,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/boulware/pom.xml
===================================================================
--- exampleparties/boulware/pom.xml	(revision 14)
+++ exampleparties/boulware/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-			<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.4.0</version>
+			<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 		</dependency>
 		<dependency>
Index: exampleparties/comparebids/pom.xml
===================================================================
--- exampleparties/comparebids/pom.xml	(revision 14)
+++ exampleparties/comparebids/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-			<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -39,10 +40,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
@@ -54,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/conceder/pom.xml
===================================================================
--- exampleparties/conceder/pom.xml	(revision 14)
+++ exampleparties/conceder/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-			<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
Index: exampleparties/hardliner/pom.xml
===================================================================
--- exampleparties/hardliner/pom.xml	(revision 14)
+++ exampleparties/hardliner/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-			<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
Index: exampleparties/humangui/pom.xml
===================================================================
--- exampleparties/humangui/pom.xml	(revision 14)
+++ exampleparties/humangui/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-			<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -39,15 +40,15 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 		<dependency>
Index: exampleparties/linear/pom.xml
===================================================================
--- exampleparties/linear/pom.xml	(revision 14)
+++ exampleparties/linear/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-			<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb.exampleparties</groupId>
 			<artifactId>timedependentparty</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
Index: exampleparties/randomparty/pom.xml
===================================================================
--- exampleparties/randomparty/pom.xml	(revision 14)
+++ exampleparties/randomparty/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -39,10 +40,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
@@ -54,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/randompartypy/pom.xml
===================================================================
--- exampleparties/randompartypy/pom.xml	(revision 14)
+++ exampleparties/randompartypy/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -31,5 +32,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>pythonadapter</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -37,15 +38,15 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/simpleshaop/pom.xml
===================================================================
--- exampleparties/simpleshaop/pom.xml	(revision 14)
+++ exampleparties/simpleshaop/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.6</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -39,10 +40,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+			<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
@@ -54,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/timedependentparty/pom.xml
===================================================================
--- exampleparties/timedependentparty/pom.xml	(revision 14)
+++ exampleparties/timedependentparty/pom.xml	(revision 18)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>1.4.0</version>
+	<version>1.4.1</version> <!-- must equal ${geniusweb.version} -->
 	<packaging>jar</packaging>
 
@@ -17,4 +17,5 @@
 		<passwd>${env.ARTIFACTORY_PASS}</passwd>
 		<jackson-2-version>2.9.10</jackson-2-version>
+		<geniusweb.version>1.4.1</geniusweb.version>
 	</properties>
 
@@ -33,5 +34,5 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>party</artifactId>
-			<version>1.4.0</version>
+	<version>${geniusweb.version}</version>
 		</dependency>
 
@@ -39,10 +40,10 @@
 			<groupId>geniusweb</groupId>
 			<artifactId>bidspace</artifactId>
-			<version>1.4.0</version>
+	<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
 			<groupId>geniusweb</groupId>
 			<artifactId>profileconnection</artifactId>
-			<version>1.4.0</version>
+	<version>${geniusweb.version}</version>
 		</dependency>
 		<dependency>
@@ -54,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>immutablelist</artifactId>
-			<version>1.0.1</version>
+			<version>1.1.0</version>
 		</dependency>
 
Index: exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 14)
+++ exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 18)
@@ -70,5 +70,5 @@
 				this.me = settings.getID();
 				this.progress = settings.getProgress();
-				Object newe = settings.getParemeters().get("e");
+				Object newe = settings.getParameters().get("e");
 				if (newe != null) {
 					if (newe instanceof Double) {